package org.processmining.generalizedconformance.algorithms.miner.distance;


public class SimpleDistanceFunction implements DistanceFunction {

    public double getFinalDistance(Distance dist) {
        return (dist.getLogDistance() + dist.getModelDistance() + 8 * (getModelLogDistance(dist)) ) / 10.;
    }

    @Override
    public double getModelLogDistance(Distance dist) {
        return 1 - DistanceHelper.getFScore(dist.getFitness(),dist.getPrecision());
    }



}
