package org.processmining.generalizedconformance.algorithms.miner.move;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by andreas on 4/13/17.
 */
public class Neighborhood<M> {
    private List<Move<M>> possibleMoves;

    public Neighborhood() {
        this.possibleMoves = new ArrayList<>(128);
    }

    public void addPossibleMove(Move<M> move){
        this.possibleMoves.add(move);
    }

    public List<Move<M>> getPossibleMoves() {
        return possibleMoves;
    }

    public int size() {
        return possibleMoves.size();
    }
}
