package org.processmining.generalizedconformance.algorithms.miner.move;

import org.processmining.generalizedconformance.algorithms.alignment.LogAbstraction;
import org.processmining.generalizedconformance.algorithms.miner.alignment.AlignmentCollector;
import org.processmining.generalizedconformance.algorithms.miner.distance.Distance;

/**
 * Created by andreas on 4/13/17.
 */
public class SearchState<M> {
    protected LogAbstraction logAbstraction;
    protected M model;

    protected Distance distance;
    protected AlignmentCollector[] alignmentCollectors;

    public SearchState(LogAbstraction logAbstraction, M model) {
        this.logAbstraction = logAbstraction;
        this.model = model;
    }

    public LogAbstraction getLogAbstraction() {
        return logAbstraction;
    }

    public void setLogAbstraction(LogAbstraction logAbstraction) {
        this.logAbstraction = logAbstraction;
    }

    public M getModel() {
        return model;
    }

    public void setModel(M model) {
        this.model = model;
    }

    public Distance getDistance() {
        return distance;
    }

    public void setDistance(Distance distance) {
        this.distance = distance;
    }

    public AlignmentCollector[] getAlignmentCollectors() {
        return alignmentCollectors;
    }

    public void setAlignmentCollectors(AlignmentCollector[] alignmentCollectors) {
        this.alignmentCollectors = alignmentCollectors;
    }
}
