package org.processmining.generalizedconformance.algorithms.mover;

import treedist.EditScore;
import treedist.LabeledTree;

public class SimpleScore implements EditScore{

	private LabeledTree tree1;
	private LabeledTree tree2;

	public SimpleScore(LabeledTree tree1, LabeledTree tree2){
		this.tree1 = tree1;
		this.tree2 = tree2;
	}
	
	public double replace(int node1, int node2) {
		if (tree1.getLabel(node1) == tree2.getLabel(node2)){
			return 0;
		} else {
			return 2;
		}
	}

	public double delete(int node1) {
		return 1;
	}

	public double insert(int node2) {
		return 1;
	}

}
